### R code from vignette source 'cr_2.Rnw'

###################################################
### code chunk number 1: cr_2.Rnw:32-33
###################################################
while (is.element("obs", search())) detach(obs)


###################################################
### code chunk number 2: cr_2.Rnw:36-38
###################################################
attach(obs)
summary(Clay1); summary(Clay2); summary(Clay5)


###################################################
### code chunk number 3: cr_2.Rnw:53-55
###################################################
stem(Clay1); hist(Clay1)
hist(Clay1)


###################################################
### code chunk number 4: cr_2.Rnw:66-69
###################################################
hist(Clay1, breaks=seq(0, 96, by=8), col="darkgray", border="black",
    main="Clay proportion in surface soil, weight %")
rug(Clay1)


###################################################
### code chunk number 5: cr_2.Rnw:80-89
###################################################
h <- hist(Clay1, breaks=seq(0, 96, by=8), plot=F)
str(h)
plot(h, col = heat.colors(length(h$mids))[length(h$count)-rank(h$count)+1],
   ylim = c(0, max(h$count)+5),
   main="Clay proportion in surface soil, weight %",
   sub="Counts shown above bar, actual values shown with rug plot")
rug(Clay1)
text(h$mids, h$count, h$count, pos=3)
rm(h)


###################################################
### code chunk number 6: cr_2.Rnw:100-101
###################################################
    obs[Clay1 > 65, ]


###################################################
### code chunk number 7: cr_2.Rnw:107-108
###################################################
    (ix <- which(Clay1 > 65)); obs[ix, ]


###################################################
### code chunk number 8: cr_2.Rnw:149-167
###################################################
par(mfrow=c(2,2))
    boxplot(Clay1, notch=T, horizontal=T,
      main="Boxplot of Clay 0-10cm")
#
hist(Clay1, freq=F, breaks=seq(0,100,5),
     main="Probability density for Clay 0-10cm")
lines(density(Clay1),lwd=2)
lines(density(Clay1, adj=.5),lwd=1)
lines(density(Clay1, adj=2),lwd=1.5)
#
qqnorm(Clay1, main="QQ plot for Clay 0-10cm vs Normal distribution",
   ylab="Clay %, 0-10cm")
qqline(Clay1, col=4)
#
qqnorm(log(Clay1), main="QQ plot for Clay 0-10cm vs lognormal distribution",
   ylab="log(Clay %), 0-10cm")
qqline(log(Clay1), col=4)
par(mfrow=c(1,1))


###################################################
### code chunk number 9: cr_2.Rnw:205-206
###################################################
t.test(Clay1, mu=30, conf.level=.99)


