### R code from vignette source 'cr_8.Rnw'

###################################################
### code chunk number 1: cr_8.Rnw:39-43
###################################################
pc <- prcomp(obs[,c("CEC1","Clay1","OC1")])
class(pc)
str(pc)
summary(pc)


###################################################
### code chunk number 2: cr_8.Rnw:58-60
###################################################
pc.s <- prcomp(obs[c(10,7,13)], scale=T)
summary(pc.s)


###################################################
### code chunk number 3: cr_8.Rnw:71-72
###################################################
pc.s$rotation


###################################################
### code chunk number 4: cr_8.Rnw:91-102
###################################################
pc.s <- prcomp(obs[c(10,7,13)], scale=T, retx=T)
plot(pc.s$x[,1], pc.s$x[,2], pch=20,
   xlab="Standardised PC 1", ylab="Standardised PC 2")
abline(h=0); abline(v=0)
abline(h=2, col="red", lty=2); abline(v=3, col="red", lty=2)
abline(h=-2, col="red", lty=2); abline(v=-3, col="red", lty=2)
(pts <- which((abs(pc.s$x[,1]) >= 3) | (abs(pc.s$x[,2]) >= 2) ))
points(pc.s$x[pts,1], pc.s$x[pts,2], pch=21, col="red", bg="blue")
text(pc.s$x[pts,1], pc.s$x[pts,2], pts, pos=4, col="red")
pc.s$x[pts, c(1,2)]
obs[pts, c(10,7,13)]


###################################################
### code chunk number 5: cr_8.Rnw:126-128
###################################################
pc <- prcomp(obs[,c("CEC1","Clay1","OC1")], retx=TRUE, center=FALSE)
summary(as.matrix(obs[,c("CEC1","Clay1","OC1")])%*%pc$rotation - pc$x)


###################################################
### code chunk number 6: cr_8.Rnw:149-151
###################################################
obs.reconstruct <- pc$x %*% solve(pc$rotation)
summary(obs.reconstruct - obs[,c("CEC1","Clay1","OC1")])


###################################################
### code chunk number 7: cr_8.Rnw:165-174
###################################################
dim(solve(pc$rotation)[1,])
dim(solve(pc$rotation)[1,,drop=T])
dim(solve(pc$rotation)[1,,drop=F])
obs.reconstruct.1 <- pc$x[,1,drop=F] %*% solve(pc$rotation)[1,,drop=F]
summary(obs[,c("CEC1","Clay1","OC1")] - obs.reconstruct.1)
obs.reconstruct.2 <- pc$x[,1:2] %*% solve(pc$rotation)[1:2,]
summary(obs[,c("CEC1","Clay1","OC1")] - obs.reconstruct.2)
obs.reconstruct <- pc$x[,1:3] %*% solve(pc$rotation)[1:3,]
summary(obs[,c("CEC1","Clay1","OC1")] - obs.reconstruct)


###################################################
### code chunk number 8: cr_8.Rnw:188-198
###################################################
resid.reconstruct.1 <- obs[,c("CEC1","Clay1","OC1")] -
                                    pc$x[,1,drop=F] %*% solve(pc$rotation)[1,,drop=F]
summary(resid.reconstruct.1)
head(sort(resid.reconstruct.1[,"OC1"]))
head(sort(resid.reconstruct.1[,"OC1"], decreasing=T))
resid.reconstruct.2 <- obs[,c("CEC1","Clay1","OC1")] -
                                    pc$x[,1:2] %*% solve(pc$rotation)[1:2,]
summary(resid.reconstruct.2)
head(sort(resid.reconstruct.2[,"OC1"]))
head(sort(resid.reconstruct.2[,"OC1"], decreasing=T))


###################################################
### code chunk number 9: cr_8.Rnw:206-222
###################################################
par(mfrow=c(1,2))
ymax <- round(max(resid.reconstruct.1[,"OC1"],
                                 resid.reconstruct.2[,"OC1"]))
ymin <- round(min(resid.reconstruct.1[,"OC1"],
                               resid.reconstruct.2[,"OC1"]))
plot(resid.reconstruct.1[,"OC1"] ~ obs[,"OC1"],
       main="Residuals, 1 PC reconstruction",
       xlab="Topsoil organic carbon, %", 
       ylab="Residual, % OC", ylim=c(ymin,ymax))
abline(h=0, lty=2)
plot(resid.reconstruct.2[,"OC1"] ~ obs[,"OC1"],
       main="Residuals, 2 PC reconstruction", xlab="Topsoil organic
       carbon, %",
       ylab="Residual, % OC", ylim=c(ymin,ymax))
abline(h=0, lty=2)
par(mfrow=c(1,1))


###################################################
### code chunk number 10: cr_8.Rnw:233-249
###################################################
par(mfrow=c(1,2))
ymax <- round(max(resid.reconstruct.1[,"CEC1"],
                         resid.reconstruct.2[,"CEC1"]))
ymin <- round(min(resid.reconstruct.1[,"CEC1"],
                         resid.reconstruct.2[,"CEC1"]))
plot(resid.reconstruct.1[,"CEC1"] ~ obs[,"CEC1"],
              main="Residuals, 1 PC reconstruction",
              xlab="Topsoil CEC, cmol+ kg-1 soil",
              ylab="Residual, % CEC", ylim=c(ymin,ymax))
abline(h=0, lty=2)
plot(resid.reconstruct.2[,"CEC1"] ~ obs[,"CEC1"],
              main="Residuals, 2 PC reconstruction",
              xlab="Topsoil CEC, cmol+ kg-1 soil",
              ylab="Residual, % CEC", ylim=c(ymin,ymax))
abline(h=0, lty=2)
par(mfrow=c(1,1))


###################################################
### code chunk number 11: cr_8.Rnw:259-261
###################################################
range(resid.reconstruct.1[,"CEC1"])
range(resid.reconstruct.2[,"CEC1"])


###################################################
### code chunk number 12: cr_8.Rnw:272-275
###################################################
resid.reconstruct.2 <- scale(obs[,c("CEC1","Clay1","OC1")]) -
                                              pc.s$x[,1:2] %*% solve(pc.s$rotation)[1:2,]
summary(resid.reconstruct.2)


###################################################
### code chunk number 13: cr_8.Rnw:280-292
###################################################
par(mfrow=c(1,2))
plot(resid.reconstruct.2[,"OC1"] ~ scale(obs[,"OC1"]),
       main="Residuals, 2 PC reconstruction",
       xlab="Topsoil organic carbon, standardized",
       ylab="Residual, % OC standardized")
abline(h=0, lty=2)
plot(resid.reconstruct.2[,"CEC1"] ~ scale(obs[,"CEC1"]),
       main="Residuals, 2 PC reconstruction",
       xlab="Topsoil CEC, standardized",
       ylab="Residual, CEC standardized")
abline(h=0, lty=2)
par(mfrow=c(1,1))


###################################################
### code chunk number 14: cr_8.Rnw:341-349
###################################################
par(mfrow=c(2,2))
biplot(pc.s, main="Biplot, Standardized PCs 1 and 2",
       pc.biplot=T, cex=c(.9,1.2))
biplot(pc.s, main="Variables only, Standardized PCs 1 and 2",
       pc.biplot=T, cex=c(0.3,1.2), xlabs=rep("o", dim(pc.s$x)[1]))
biplot(pc.s, main="Observations only, Standardized PCs 1 and 2",
       pc.biplot=T, var.axes=F, cex=c(1,0.1))
par(mfrow=c(1,1))


###################################################
### code chunk number 15: cr_8.Rnw:374-375
###################################################
obs[c(1,2,78,81),c(7,10,13)]


###################################################
### code chunk number 16: cr_8.Rnw:412-415
###################################################
pc9 <- prcomp(obs[7:15], scale=T)
summary(pc9)
screeplot(pc9, main="Screeplot, 9 principal components")


###################################################
### code chunk number 17: cr_8.Rnw:434-439
###################################################
par(mfrow=c(2,2))
biplot(pc9, pc.biplot=T, main="Standardized PCs 1 and 2")
biplot(pc9, choice=2:3, pc.biplot=T, main="Standardized PCs 2 and 3")
biplot(pc9, choice=c(1,3), pc.biplot=T, main="Standardized PCs 1 and 3")
par(mfrow=c(1,1))


###################################################
### code chunk number 18: cr_8.Rnw:472-473
###################################################
(fa <- factanal(obs[7:15], 3))


###################################################
### code chunk number 19: cr_8.Rnw:495-496
###################################################
(fa <- update(fa, factors = 4))


###################################################
### code chunk number 20: cr_8.Rnw:507-521
###################################################
par(mfrow=c(2,2))
plot(loadings(fa), xlim=c(-.1,1.1), ylim=c(-.1,1.1), type="n",
     main="Loadings 1 and 2, 4-factor model")
text(loadings(fa),dimnames(loadings(fa))[[1]])
plot(loadings(fa)[,c(1,3)], xlim=c(-.1,1.1), ylim=c(-.1,1.1), type="n",
     main="Loadings 1 and 3, 4-factor model")
text(loadings(fa)[,c(1,3)],dimnames(loadings(fa))[[1]])
plot(loadings(fa)[,2:3], xlim=c(-.1,1.1), ylim=c(-.1,1.1), type="n",
     main="Loadings 2 and 3, 4-factor model")
text(loadings(fa)[,2:3],dimnames(loadings(fa))[[1]])
plot(loadings(fa)[,3:4], xlim=c(-.1,1.1), ylim=c(-.1,1.1), type="n",
     main="Loadings 3 and 4, 4-factor model")
text(loadings(fa)[,3:4],dimnames(loadings(fa))[[1]])
par(mfrow=c(1,1))


